/*{{{}}}*/
#include <math.h>
/*{{{  #define constants*/
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif
/*}}}  */
/*{{{  #define macros*/
#ifndef sqr
#define sqr(x) ((x)*(x))
#endif
/*}}}  */
/*{{{  rolloff(t, a, d, mag, ph)*/
int
rolloff(t, a, d, mag, ph)
    double t;    /* time */
    double a;    /* rolloff rate */
    double d;    /* distribution rate */
    double *mag; /* magnitude */
    double *ph;  /* phase */
{
    *ph = 0.0;
    if(t < (1.0 - a)/2.0){
        *mag = 1.0;
    }else if((t >= (1.0 - a)/2.0) && (t <= (1.0 + a)/2.0)){
        if(a != 0.0){
            *mag = pow(0.5 - 0.5 * sin(M_PI * (t - 0.5) / a), d);
        }else{
            *mag = 0.5;
        }
    }else{
        *mag = 0.0;
    }
    return(0);
}
/*}}}  */
